#ifndef CONFIGWINDOW_H
#define CONFIGWINDOW_H

#include "useful.h"

#include "SelectionWindow.h"
#include "ImageRecorder.h"
#include "glstreamrenderer.h"

#include "ImageHandler.h"
#include "tcpserverimagehandler.h"
#include "SimpleImageSaver.h"
 #include <QSlider>
#include <QInputDialog>

//Main window handleing all the gui configurations
//and starting the ImageRecorder

class ConfigWindow : public QWidget
{
    Q_OBJECT
    public:
        ConfigWindow(QWidget *parent = 0,QApplication *qapp = NULL);
        virtual ~ConfigWindow();

    public slots:
        void SLOT_startSelection();
        void SLOT_startStopCapture();
        void SLOT_captureEnded(int);

    signals:
        void SIG_startSelectionSignal();

        void SIG_startCapture(const ConfigStructure *);
        void SIG_stopCapture();

    private:
        SelectionWindow* selectionWindow;
        ImageRecorder* imageRecorder;
        ConfigStructure config;

        SimpleImageSaver* imageSaver;
        GLStreamRenderer* GLrenderer;
        QSlider* textureSlider;

        TcpServerImagehandler* tcpserver;

        QPushButton* selectButton;
        QPushButton* start;
        QApplication* qMainApp;

        QLabel* selectionLabel;
        QRadioButton* selectTcpServer;
        QRadioButton* selectImageSaver;

        QLabel* fpsLabel;
        QSpinBox* fpsBox;

        bool startedCapturing;
};

#endif // CONFIGWINDOW_H
