#ifndef SELECTIONWINDOW_H
#define SELECTIONWINDOW_H

#include "useful.h"

//Handles interactions with the rectangle
//rendered to the screen
class SelectionWindow : public QWidget
{
    Q_OBJECT
    public:
        SelectionWindow(QWidget *parent = 0);
        virtual ~SelectionWindow();
        void setSelectionImage(const QPixmap &);
        QRect* getSelectionRectangle();

    public slots:
        void SLOT_updateRecSize();

    signals:
        void doneSelected(QRect*);

    protected:
        void paintEvent(QPaintEvent*);
        void mouseMoveEvent(QMouseEvent*);
        void mouseReleaseEvent(QMouseEvent*);
        void mousePressEvent(QMouseEvent*);

    private:
        QPushButton* close;
        QPixmap currentPixMap;
        QRect selectionRectangle;
        QSpinBox* xSize;
        QSpinBox* ySize;

        QPoint oldMousePoint;
        bool isMoving;
};

#endif // SELECTIONWINDOW_H
