#ifndef GLSTREAMRENDERER_H
#define GLSTREAMRENDERER_H

#include <QGLWidget>
#include "ioimagehandler.h"
#include <iostream>
#include <vector>

using std::vector;

//GL renderer which can handle texture updates

class GLStreamRenderer : public QGLWidget
{
    Q_OBJECT
    public:
        GLStreamRenderer(QWidget *parent = 0);
        virtual ~GLStreamRenderer();
        void initializeGL();
        void resizeGL(int w, int h);
        void paintGL();
        QSize minimumSizeHint() const;
        QSize sizeHint() const;
        void connectIOhandler(IOImageHandler*);

    public slots:
        void updateTexture();
        void updateTexture(const QPixmap &);
        void updateAndStoreTexture(const QPixmap &pmap);
        void selectTexture(int i);

    protected:
        void quad(GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2,
                     GLdouble x3, GLdouble y3, GLdouble x4, GLdouble y4);
    private:
        QImage currentImage;
        GLuint currentTexture;
        IOImageHandler *imHandler;

        vector<GLuint> textures;
};

#endif // GLSTREAMRENDERER_H
