#include "tcpclientimagehandler.h"
#include <iostream>

TCPclientImagehandler::TCPclientImagehandler()
{
    theIODevice = &socket;
}

TCPclientImagehandler::~TCPclientImagehandler()
{
    delete dataStream;
    delete theIODevice;
}

void TCPclientImagehandler::connectToHost(QString hostIP,int hostPort)
{

    socket.connectToHost(hostIP,hostPort);
    dataStream = new QDataStream(&socket);
    dataStream->setVersion(10);

    connect(&socket,SIGNAL(readyRead()),this,SLOT(readImage()));
    socket.waitForConnected ();
    socket.open(QIODevice::ReadWrite);
    blockSize = 0;
    std::cout << "Client created: " << socket.errorString().toLatin1().data() << std::endl;
}

void TCPclientImagehandler::readImage()
{
    //the first block in the stream is the size of the image
    if (blockSize == 0) {
         if (socket.bytesAvailable() < (int)sizeof(qint64))
             return;
         *dataStream >> blockSize;
         socket.reset();
          std::cout << "Length read! " << blockSize << std::endl;
     }
    //If the stream is smalller than blockszie will we wait
     if (socket.bytesAvailable() < blockSize) {
            std::cout << socket.bytesAvailable() << " need " <<  blockSize << std::endl;
         return;
     }
    std::cout << "Complete image written!" << std::endl;
    //if all is well will the whole image be in the stream
    socket.reset();
    emit SIG_imageWritten();
    blockSize = 0;
}

void TCPclientImagehandler::SLOT_reqNewImage()
{
    socket.write("N");
    socket.reset();
    std::cout << "Image requested!" << std::endl;
}
